expanded class IDENTITY
inherit
   ANY
      redefine
         deep_twin,
         is_deep_equal,
         out
      end
creation default_create
feature {ANY}

   default_create is
      do
         out := generator.twin;
         identity_counter.set_item(identity_counter.item + 1);
         identity_counter.item.append_in(out);
      end

   set_out (new_out : STRING) is
      do
         out := new_out;
      end

   out : STRING

   deep_twin : like Current is
      do
         Result.set_out(out);
      end

   is_deep_equal(other : IDENTITY) : BOOLEAN is
      do
         Result := (out = other.out);
      end

feature {NONE}

   identity_counter : INTEGER_REF is
      once
         !!Result
      end

end -- class IDENTITY
