indexing 
   description: "Abstract notion of a protocol entity, OSI style"
   note: ""
   status: "$State: Exp $"
   date: "$Date: 2000/01/06 16:57:09 $"
   revision: "$Revision: 1.1 $"
   author: "Alain Le Guennec"
deferred class PROXY
feature

   initialize is
         -- Setup the initial state
      do 
      end -- initialize 

feature {ANY} -- Queries

   server: ANY

feature {ANY} -- Commands

   connect (new_server: like server) is
         -- set a new server 
      do 
         server := new_server
      ensure
         connected: server = new_server
      end -- connect

   send (e: EVENT) is
         -- send the event to the server
      require 
         connected: server /= Void
         e_not_void: e /= Void
      do 
         e.send_to(server) 
      end -- send  

invariant
end -- class PROXY
