indexing
   description: "Quick & dirty implementation of the corresponding ISE class"
   note: "Usefull for SmallEiffel"
   status: "$State: Exp $"
   date: "$Date: 2000/01/06 16:57:09 $"
   revision: "$Revision: 1.1 $"
   author: "Jean-Marc Jezequel"
class SORTED_TWO_WAY_LIST[T->COMPARABLE]
inherit TWO_WAY_LINKED_LIST[T]
creation make
feature
   start is do end
   prune (x: T) is
         -- Remove first occurrence of `x', if any, after cursor position.
      do
	 remove(fast_index_of(x))
      end -- prune
   extend (new: T) is
      local i : INTEGER
      do
	 from i := lower 
	 invariant items_so_far_less_than_new: i > 1 implies item(i-1) <= new
	 until i > upper or else new < item(i) 
	 loop
	    i := i + 1
	 end -- loop
	 add(new,i)
      end -- extend
end -- SORTED_TWO_WAY_LIST

