deferred class STATE_MACHINE
inherit
   REACTIVE
feature {STATE_MACHINE}

   entry is do end;

   exit  is do end;

   enter (new_state : STATE_MACHINE) is
      require
         valid_state: new_state /= Void
      local
         target : STATE_MACHINE;
      do
         target := Current;
         c_inline_c("_target->id=a1->id; /* Ugly hack! */");
         target.entry;
      end -- enter

   leave (old_state : STATE_MACHINE) is
      local
         target : STATE_MACHINE;
      do
         target := Current;
         c_inline_c("_target->id=a1->id; /* Ugly hack! */");
         target.exit;
      end -- leave

   oclInState(other : STATE_MACHINE) : BOOLEAN is
      local
         target : STATE_MACHINE;
      do
         target := Current;
         Result := target.conforms_to(other);
      end -- oclInState

invariant
end -- class STATE_MACHINE
