class LINKED_QUEUE[E]
inherit
   ARRAY[E]
      rename item  as array_item,
             put   as array_put,
             remove as array_remove,
             first as item,
             add_last as put
--             remove_first as remove
      redefine
         out
      end;
creation make, with_capacity
feature {ACTIVABLE}

   remove is
      require
         count > 0
      do
         array_remove(lower);
         storage.put(void, count)
      end

feature {ANY}

   out : STRING is
      local
         i : INTEGER
      do
         !!Result.make_from_string ("There are ");
         Result.append(count.out)
         Result.append(" queued messages:%N");
         from
            i := lower
         until
            i > upper
         loop
            Result.append(array_item(i).out);
            Result.extend('%N');
            i := i + 1
         end;
      end

end -- LINKED_QUEUE
